diff --git a/cli.py b/cli.py
old mode 100644
new mode 100755
index 6056d38..aa73278
--- a/cli.py
+++ b/cli.py
@@ -25,7 +25,7 @@ import sys
 import time
 import random
 import logging
-from optparse import OptionParser,OptionGroup
+from optparse import OptionParser,OptionGroup,SUPPRESS_HELP
 import rpm
 
 from weakref import proxy as weakref
@@ -43,31 +43,34 @@ from yum.rpmtrans import RPMTransaction
 import signal
 import yumcommands
 
-from yum.i18n import to_unicode, to_utf8
+from yum.i18n import to_unicode, to_utf8, exception2msg
 
 #  This is for yum-utils/yumdownloader in RHEL-5, where it isn't importing this
 # directly but did do "from cli import *", and we did have this in 3.2.22. I
 # just _love_ how python re-exports these by default.
+# pylint: disable-msg=W0611
 from yum.packages import parsePackages
+# pylint: enable-msg=W0611
 
 def sigquit(signum, frame):
-    """ SIGQUIT handler for the yum cli. """
+    """SIGQUIT handler for the yum cli.  This function will print an
+    error message and exit the program.
+    
+    :param signum: unused
+    :param frame: unused
+    """
     print >> sys.stderr, "Quit signal sent - exiting immediately"
     sys.exit(1)
 
 class CliError(yum.Errors.YumBaseError):
-
-    """
-    Command line interface related Exception.
-    """
+    """Command line interface related Exception."""
 
     def __init__(self, args=''):
         yum.Errors.YumBaseError.__init__(self)
         self.args = args
 
 class YumBaseCli(yum.YumBase, output.YumOutput):
-    """This is the base class for yum cli.
-       Inherits from yum.YumBase and output.YumOutput """
+    """This is the base class for yum cli."""
        
     def __init__(self):
         # handle sigquit early on
@@ -84,6 +87,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         self.registerCommand(yumcommands.InfoCommand())
         self.registerCommand(yumcommands.ListCommand())
         self.registerCommand(yumcommands.EraseCommand())
+        self.registerCommand(yumcommands.AutoremoveCommand())
         self.registerCommand(yumcommands.GroupsCommand())
         self.registerCommand(yumcommands.MakeCacheCommand())
         self.registerCommand(yumcommands.CleanCommand())
@@ -104,17 +108,32 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         self.registerCommand(yumcommands.CheckRpmdbCommand())
         self.registerCommand(yumcommands.DistroSyncCommand())
         self.registerCommand(yumcommands.LoadTransactionCommand())
+        self.registerCommand(yumcommands.SwapCommand())
+        self.registerCommand(yumcommands.RepoPkgsCommand())
+        self.registerCommand(yumcommands.UpdateinfoCommand())
+        self.registerCommand(yumcommands.UpdateMinimalCommand())
+        self.registerCommand(yumcommands.FSSnapshotCommand())
+        self.registerCommand(yumcommands.FSCommand())
 
     def registerCommand(self, command):
+        """Register a :class:`yumcommands.YumCommand` so that it can be called by
+        any of the names returned by its
+        :func:`yumcommands.YumCommand.getNames` method.
+        
+        :param command: the :class:`yumcommands.YumCommand` to register
+        """
         for name in command.getNames():
             if name in self.yum_cli_commands:
                 raise yum.Errors.ConfigError(_('Command "%s" already defined') % name)
             self.yum_cli_commands[name] = command
             
     def doRepoSetup(self, thisrepo=None, dosack=1):
-        """grabs the repomd.xml for each enabled repository 
-           and sets up the basics of the repository"""
-        
+        """Grab the repomd.xml for each enabled and set up the basics
+        of the repository.
+
+        :param thisrepo: the repository to set up
+        :param dosack: whether to get the repo sack
+        """
         if self._repos and thisrepo is None:
             return self._repos
             
@@ -163,9 +182,19 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         mainopts = yum.misc.GenericHolder()
         mainopts.items = []
 
+        bad_setopt_tm = []
+        bad_setopt_ne = []
+
         for item in setopts:
-            k,v = item.split('=')
-            period = k.find('.') 
+            vals = item.split('=')
+            if len(vals) > 2:
+                bad_setopt_tm.append(item)
+                continue
+            if len(vals) < 2:
+                bad_setopt_ne.append(item)
+                continue
+            k, v = [i.strip() for i in vals]
+            period = k.rfind('.')
             if period != -1:
                 repo = k[:period]
                 k = k[period+1:]
@@ -180,13 +209,15 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         
         self.main_setopts = mainopts
         self.repo_setopts = repoopts
-        
+
+        return bad_setopt_tm, bad_setopt_ne
         
     def getOptionsConfig(self, args):
-        """parses command line arguments, takes cli args:
-        sets up self.conf and self.cmds as well as logger objects 
-        in base instance"""
-       
+        """Parse command line arguments, and set up :attr:`self.conf` and
+        :attr:`self.cmds`, as well as logger objects in base instance.
+
+        :param args: a list of command line arguments
+        """
         self.optparser = YumOptionParser(base=self, usage=self._makeUsage())
         
         # Parse only command line options that affect basic yum setup
@@ -199,7 +230,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             opts.verbose = False
 
         # go through all the setopts and set the global ones
-        self._parseSetOpts(opts.setopts)
+        bad_setopt_tm, bad_setopt_ne = self._parseSetOpts(opts.setopts)
         
         if self.main_setopts:
             for opt in self.main_setopts.items:
@@ -229,6 +260,12 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             pc.releasever = opts.releasever
             self.conf
             
+            for item in  bad_setopt_tm:
+                msg = "Setopt argument has multiple values: %s"
+                self.logger.warning(msg % item)
+            for item in  bad_setopt_ne:
+                msg = "Setopt argument has no value: %s"
+                self.logger.warning(msg % item)
             # now set  all the non-first-start opts from main from our setopts
             if self.main_setopts:
                 for opt in self.main_setopts.items:
@@ -238,10 +275,14 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                     setattr(self.conf, opt, getattr(self.main_setopts, opt))
 
         except yum.Errors.ConfigError, e:
-            self.logger.critical(_('Config Error: %s'), e)
+            self.logger.critical(_('Config error: %s'), e)
+            sys.exit(1)
+        except IOError, e:
+            e = '%s: %s' % (to_unicode(e.args[1]), repr(e.filename))
+            self.logger.critical(_('Config error: %s'), e)
             sys.exit(1)
         except ValueError, e:
-            self.logger.critical(_('Options Error: %s'), e)
+            self.logger.critical(_('Options error: %s'), e)
             sys.exit(1)
 
         # update usage in case plugins have added commands
@@ -263,11 +304,11 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         if opts.verbose:
             opts.debuglevel = opts.errorlevel = 6
         if opts.debuglevel != pc.debuglevel or opts.errorlevel != pc.errorlevel:
-            self.logger.warning("Ignored option -q, -v, -d or -e (probably due to merging: -yq != -y -q)")
+            self.logger.warning(_("Ignored option -q, -v, -d or -e (probably due to merging: -yq != -y -q)"))
         #  getRoot() changes it, but then setupYumConfig() changes it back. So
         # don't test for this, if we are using --installroot.
         if root == '/' and opts.conffile != pc.fn:
-            self.logger.warning("Ignored option -c (probably due to merging -yc != -y -c)")
+            self.logger.warning(_("Ignored option -c (probably due to merging -yc != -y -c)"))
 
         if opts.version:
             self.conf.cache = 1
@@ -290,9 +331,9 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                                    self.term.MODE['normal'])
                 print _("  Installed: %s-%s at %s") %(name, ver,
                                                    sm_ui_time(pkg.installtime))
-                print _("  Built    : %s at %s") % (pkg.packager,
+                print _("  Built    : %s at %s") % (to_unicode(pkg.packager),
                                                     sm_ui_time(pkg.buildtime))
-                print _("  Committed: %s at %s") % (pkg.committer,
+                print _("  Committed: %s at %s") % (to_unicode(pkg.committer),
                                                     sm_ui_date(pkg.committime))
             sys.exit(0)
 
@@ -318,10 +359,12 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         time.sleep(sleeptime)
         
     def parseCommands(self):
-        """reads self.cmds and parses them out to make sure that the requested 
-        base command + argument makes any sense at all""" 
-
-        self.verbose_logger.debug('Yum Version: %s', yum.__version__)
+        """Read :attr:`self.cmds` and parse them out to make sure that
+        the requested base command and argument makes any sense at
+        all.  This function will also set :attr:`self.basecmd` and
+        :attr:`self.extcmds`.
+        """
+        self.verbose_logger.debug('Yum version: %s', yum.__version__)
         self.verbose_logger.log(yum.logginglevels.DEBUG_4,
                                 'COMMAND: %s', self.cmdstring)
         self.verbose_logger.log(yum.logginglevels.DEBUG_4,
@@ -349,8 +392,57 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                                   self.basecmd, sys.argv[0])
             raise CliError
     
+        self._set_repos_cache_req()
+
         self.yum_cli_commands[self.basecmd].doCheck(self, self.basecmd, self.extcmds)
 
+    def _set_repos_cache_req(self, warning=True):
+        """ Set the cacheReq attribute from the commands to the repos. """
+
+        cmd = self.yum_cli_commands[self.basecmd]
+        cacheReq = 'write'
+        if hasattr(cmd, 'cacheRequirement'):
+            cacheReq = cmd.cacheRequirement(self, self.basecmd, self.extcmds)
+
+        #  The main thing we want to do here is that if the user has done a
+        # "yum makecache fast" or has yum-cron running or something, then try
+        # not to update the repo. caches ... thus. not turning 0.5s ops. into
+        # 100x longer ops.
+        #  However if the repos. are not in sync. that's probably not going to
+        # work well (Eg. user enables updates-testing). Also give a warning if
+        # they are _really_ old.
+        ts_min = None
+        ts_max = None
+        for repo in self.repos.listEnabled():
+            try: rts = os.stat(repo.metadata_cookie).st_mtime
+            except (yum.Errors.RepoError, OSError):
+                ts_min = None
+                break
+
+            if not ts_min:
+                ts_min = rts
+                ts_max = rts
+            elif rts > ts_max:
+                ts_max = rts
+            elif rts < ts_min:
+                ts_min = rts
+
+        if ts_min:
+            #  If caches are within 5 days of each other, they are ok to work
+            # together (lol, random numbers)...
+            if (ts_max - ts_min) > (60 * 60 * 24 * 5):
+                ts_min = None
+            elif ts_max > time.time():
+                ts_min = None
+
+        if not ts_min:
+            cacheReq = 'write'
+        elif warning and (time.time() - ts_max) > (60 * 60 * 24 * 14):
+            self.logger.warning(_("Repodata is over 2 weeks old. Install yum-cron? Or run: yum makecache fast"))
+
+        for repo in self.repos.sort():
+            repo._metadata_cache_req = cacheReq
+
     def _shell_history_write(self):
         if not hasattr(self, '_shell_history_cmds'):
             return
@@ -365,7 +457,11 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         self.history.write_addon_data('shell-cmds', data)
 
     def doShell(self):
-        """do a shell-like interface for yum commands"""
+        """Run a shell-like interface for yum commands.
+
+        :return: a tuple containing the shell result number, and the
+           shell result messages
+        """
 
         yumshell = shell.YumShell(base=self)
 
@@ -382,8 +478,12 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return yumshell.result, yumshell.resultmsgs
 
     def errorSummary(self, errstring):
-        """ parse the error string for 'interesting' errors which can
-            be grouped, such as disk space issues """
+        """Parse the error string for 'interesting' errors which can
+        be grouped, such as disk space issues.
+
+        :param errstring: the error string
+        :return: a string containing a summary of the errors
+        """
         summary = ''
         # do disk space report first
         p = re.compile('needs (\d+)MB on the (\S+) filesystem')
@@ -407,17 +507,45 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return summary
 
 
-    def doCommands(self):
-        """
-        Calls the base command passes the extended commands/args out to be
-        parsed (most notably package globs).
-        
-        Returns a numeric result code and an optional string
-           - 0 = we're done, exit
-           - 1 = we've errored, exit with error string
-           - 2 = we've got work yet to do, onto the next stage
+    def waitForLock(self):
+        """Establish the yum lock.  If another process is already
+        holding the yum lock, by default this method will keep trying
+        to establish the lock until it is successful.  However, if
+        :attr:`self.conf.exit_on_lock` is set to True, it will
+        raise a :class:`Errors.YumBaseError`.
         """
-        
+        lockerr = ""
+        while True:
+            try:
+                self.doLock()
+            except yum.Errors.LockError, e:
+                if exception2msg(e) != lockerr:
+                    lockerr = exception2msg(e)
+                    self.logger.critical(lockerr)
+                if e.errno:
+                    raise yum.Errors.YumBaseError, _("Can't create lock file; exiting")
+                if not self.conf.exit_on_lock:
+                    self.logger.critical("Another app is currently holding the yum lock; waiting for it to exit...")
+                    import utils
+                    utils.show_lock_owner(e.pid, self.logger)
+                    time.sleep(2)
+                else:
+                    raise yum.Errors.YumBaseError, _("Another app is currently holding the yum lock; exiting as configured by exit_on_lock")
+            else:
+                break
+
+    def doCommands(self):
+        """Call the base command, and pass it the extended commands or
+           arguments.
+
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """       
         # at this point we know the args are valid - we don't know their meaning
         # but we know we're not being sent garbage
         
@@ -435,14 +563,37 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             try:
                 self._getTs(needTsRemove)
             except yum.Errors.YumBaseError, e:
-                return 1, [str(e)]
+                return 1, [exception2msg(e)]
+
+        #  This should already have been done at doCheck() time, but just in
+        # case repos. got added or something do it again.
+        self._set_repos_cache_req(warning=False)
 
         return self.yum_cli_commands[self.basecmd].doCommand(self, self.basecmd, self.extcmds)
 
     def doTransaction(self):
-        """takes care of package downloading, checking, user confirmation and actually
-           RUNNING the transaction"""
-    
+        """Take care of package downloading, checking, user
+        confirmation and actually running the transaction.
+
+        :return: a numeric return code, and optionally a list of
+           errors.  A negative return code indicates that errors
+           occurred in the pre-transaction checks
+        """
+        def _downloadonly_userconfirm(self):
+            #  Note that we shouldn't just remove the 'd' option, or the options
+            # yum accepts will be different which is bad. So always accept it,
+            # but change the prompt.
+            dl_only = {'downloadonly' :
+                             (u'd', _('d'), _('download'),
+                              _('downloadonly'))}
+            if not stuff_to_download:
+                ret = self.userconfirm(extra=dl_only)
+                if ret == 'downloadonly':
+                    ret = None
+                return ret
+            return self.userconfirm(prompt=_('Is this ok [y/d/N]: '),
+                                    extra=dl_only)
+
         # just make sure there's not, well, nothing to do
         if len(self.tsInfo) == 0:
             self.verbose_logger.info(_('Trying to run the transaction but nothing to do. Exiting.'))
@@ -453,7 +604,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         lsts = self.listTransaction()
         if self.verbose_logger.isEnabledFor(yum.logginglevels.INFO_1):
             self.verbose_logger.log(yum.logginglevels.INFO_1, lsts)
-        elif not self.conf.assumeyes:
+        elif self.conf.assumeno or not self.conf.assumeyes:
             #  If we are in quiet, and assumeyes isn't on we want to output
             # at least the transaction list anyway.
             self.logger.warn(lsts)
@@ -463,7 +614,6 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         rmpkgs = []
         stuff_to_download = False
         install_only = True
-        remove_only  = True
         for txmbr in self.tsInfo.getMembers():
             if txmbr.ts_state not in ('i', 'u'):
                 install_only = False
@@ -471,7 +621,6 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 if po:
                     rmpkgs.append(po)
             else:
-                remove_only = False
                 stuff_to_download = True
                 po = txmbr.po
                 if po:
@@ -489,19 +638,40 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         else:
             self.reportDownloadSize(downloadpkgs, install_only)
         
+        cfr = self.tsInfo._check_future_rpmdbv
+        if (cfr is not None and
+            self.tsInfo.futureRpmDBVersion() != cfr[1]):
+            msg = _("future rpmdb ver mismatched saved transaction version,")
+            if cfr[2]:
+                msg += _(" ignoring, as requested.")
+                self.logger.critical(_(msg))
+            else:
+                msg += _(" aborting.")
+                raise yum.Errors.YumBaseError(msg)
+
         # confirm with user
         if self._promptWanted():
-            if not self.userconfirm():
-                self.verbose_logger.info(_('Exiting on user Command'))
+            uc = None
+            if not self.conf.assumeno:
+                uc = _downloadonly_userconfirm(self)
+
+            if not uc:
+                self.verbose_logger.info(_('Exiting on user command'))
                 return -1
+            elif uc == 'downloadonly':
+                self.conf.downloadonly = True
 
-        self.verbose_logger.log(yum.logginglevels.INFO_2,
-            _('Downloading Packages:'))
+        if self.conf.downloadonly:
+            self.verbose_logger.log(yum.logginglevels.INFO_2,
+                                    _('Background downloading packages, then exiting:'))
+        else:
+            self.verbose_logger.log(yum.logginglevels.INFO_2,
+                                    _('Downloading packages:'))
         problems = self.downloadPkgs(downloadpkgs, callback_total=self.download_callback_total_cb) 
 
         if len(problems) > 0:
             errstring = ''
-            errstring += _('Error Downloading Packages:\n')
+            errstring += _('Error downloading packages:\n')
             for key in problems:
                 errors = yum.misc.unique(problems[key])
                 for error in errors:
@@ -520,8 +690,9 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
 
         rcd_st = time.time()
         self.verbose_logger.log(yum.logginglevels.INFO_2, 
-             _('Running Transaction Check'))
+             _('Running transaction check'))
         msgs = self._run_rpm_check()
+        depsolve = False
         if msgs:
             rpmlib_only = True
             for msg in msgs:
@@ -532,21 +703,23 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 print _("ERROR You need to update rpm to handle:")
             else:
                 print _('ERROR with transaction check vs depsolve:')
+                depsolve = True
 
             for msg in msgs:
                 print to_utf8(msg)
 
             if rpmlib_only:
                 return 1, [_('RPM needs to be updated')]
-            return 1, [_('Please report this error in %s') % self.conf.bugtracker_url]
+            if depsolve:
+                return 1, []
+            else:
+                return 1, [_('Please report this error in %s') % self.conf.bugtracker_url]
 
-        self.verbose_logger.debug('Transaction Check time: %0.3f' % (time.time() - rcd_st))
+        self.verbose_logger.debug('Transaction check time: %0.3f' % (time.time() - rcd_st))
 
         tt_st = time.time()            
         self.verbose_logger.log(yum.logginglevels.INFO_2,
-            _('Running Transaction Test'))
-        if not self.conf.diskspacecheck:
-            self.tsInfo.probFilterFlags.append(rpm.RPMPROB_FILTER_DISKSPACE)
+            _('Running transaction test'))
             
         self.ts.order() # order the transaction
         self.ts.clean() # release memory not needed beyond this point
@@ -556,16 +729,16 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         del testcb
 
         if len(tserrors) > 0:
-            errstring = _('Transaction Check Error:\n')
+            errstring = _('Transaction check error:\n')
             for descr in tserrors:
                 errstring += '  %s\n' % to_unicode(descr)
             
             raise yum.Errors.YumBaseError, errstring + '\n' + \
                  self.errorSummary(errstring)
         self.verbose_logger.log(yum.logginglevels.INFO_2,
-             _('Transaction Test Succeeded'))
+             _('Transaction test succeeded'))
         
-        self.verbose_logger.debug('Transaction Test time: %0.3f' % (time.time() - tt_st))
+        self.verbose_logger.debug('Transaction test time: %0.3f' % (time.time() - tt_st))
         
         # unset the sigquit handler
         signal.signal(signal.SIGQUIT, signal.SIG_DFL)
@@ -595,7 +768,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         if self.conf.debuglevel < 2:
             cb.display.output = False
 
-        self.verbose_logger.log(yum.logginglevels.INFO_2, _('Running Transaction'))
+        self.verbose_logger.log(yum.logginglevels.INFO_2, _('Running transaction'))
         resultobject = self.runTransaction(cb=cb)
 
         self.verbose_logger.debug('Transaction time: %0.3f' % (time.time() - ts_st))
@@ -609,12 +782,14 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return resultobject.return_code
         
     def gpgsigcheck(self, pkgs):
-        '''Perform GPG signature verification on the given packages, installing
-        keys if possible
+        """Perform GPG signature verification on the given packages,
+        installing keys if possible.
 
-        Returns non-zero if execution should stop (user abort).
-        Will raise YumBaseError if there's a problem
-        '''
+        :param pkgs: a list of package objects to verify the GPG
+           signatures of
+        :return: non-zero if execution should stop due to an error
+        :raises: Will raise :class:`YumBaseError` if there's a problem
+        """
         for po in pkgs:
             result, errmsg = self.sigCheckPkg(po)
 
@@ -623,7 +798,8 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 continue            
 
             elif result == 1:
-                if not sys.stdin.isatty() and not self.conf.assumeyes:
+                ay = self.conf.assumeyes and not self.conf.assumeno
+                if not sys.stdin.isatty() and not ay:
                     raise yum.Errors.YumBaseError, \
                             _('Refusing to automatically import keys when running ' \
                             'unattended.\nUse "-y" to override.')
@@ -691,12 +867,62 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                                      ", ".join(matches))
             self.verbose_logger.log(yum.logginglevels.INFO_2, msg)
 
-    def installPkgs(self, userlist):
-        """Attempts to take the user specified list of packages/wildcards
-           and install them, or if they are installed, update them to a newer
-           version. If a complete version number if specified, attempt to 
-           upgrade (or downgrade if they have been removed) them to the
-           specified version"""
+    def _install_upgraded_requires(self, txmbrs):
+        """Go through the given txmbrs, and for any to be installed packages
+        look for their installed deps. and try to upgrade them, if the
+        configuration is set. Returning any new transaction members to be
+        isntalled.
+
+        :param txmbrs: a list of :class:`yum.transactioninfo.TransactionMember` objects
+        :return: a list of :class:`yum.transactioninfo.TransactionMember` objects
+        """
+
+        if not self.conf.upgrade_requirements_on_install:
+            return []
+
+        ret = []
+        done = set()
+        def _pkg2ups(pkg, reqpo=None):
+            if pkg.name in done:
+                return []
+            if reqpo is None:
+                reqpo = pkg
+
+            done.add(pkg.name)
+
+            uret = []
+            for req in pkg.requires:
+                for npkg in self.returnInstalledPackagesByDep(req):
+                    if npkg.name in done:
+                        continue
+                    uret += self.update(name=npkg.name, requiringPo=reqpo)
+                    uret += _pkg2ups(npkg, reqpo=reqpo)
+            return uret
+
+        for txmbr in txmbrs:
+            for rtxmbr, T in txmbr.relatedto:
+                ret += _pkg2ups(rtxmbr)
+            ret += _pkg2ups(txmbr.po)
+
+        return ret
+
+    def installPkgs(self, userlist, basecmd='install', repoid=None):
+        """Attempt to take the user specified list of packages or
+        wildcards and install them, or if they are installed, update
+        them to a newer version. If a complete version number is
+        specified, attempt to upgrade (or downgrade if they have been
+        removed) them to the specified version.
+
+        :param userlist: a list of names or wildcards specifying
+           packages to install
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         # get the list of available packages
         # iterate over the user's list
         # add packages to Transaction holding class if they match.
@@ -710,11 +936,38 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         for arg in userlist:
             if (arg.endswith('.rpm') and (yum.misc.re_remote_url(arg) or
                                           os.path.exists(arg))):
-                self.localInstall(filelist=[arg])
+                txmbrs = self.installLocal(arg)
+                self._install_upgraded_requires(txmbrs)
                 continue # it was something on disk and it ended in rpm 
                          # no matter what we don't go looking at repos
             try:
-                self.install(pattern=arg)
+                if False: pass
+                elif basecmd == 'install-n':
+                    txmbrs = self.install(name=arg)
+                elif basecmd == 'install-na':
+                    try:
+                        n,a = arg.rsplit('.', 1)
+                    except:
+                        self.verbose_logger.warning(_('Bad %s argument %s.'),
+                                                    basecmd, arg)
+                        continue
+                    txmbrs = self.install(name=n, arch=a)
+                elif basecmd == 'install-nevra':
+                    try:
+                        nevr,a = arg.rsplit('.', 1)
+                        n,ev,r = nevr.rsplit('-', 2)
+                        e,v    = ev.split(':', 1)
+                    except:
+                        self.verbose_logger.warning(_('Bad %s argument %s.'),
+                                                    basecmd, arg)
+                        continue
+                    txmbrs = self.install(name=n,
+                                          epoch=e, version=v, release=r, arch=a)
+                else:
+                    assert basecmd == 'install', basecmd
+                    txmbrs = self.install(pattern=arg)
+            except yum.Errors.GroupInstallError, e:
+                self.verbose_logger.log(yum.logginglevels.INFO_2, e)
             except yum.Errors.InstallError:
                 self.verbose_logger.log(yum.logginglevels.INFO_2,
                                         _('No package %s%s%s available.'),
@@ -723,6 +976,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 self._maybeYouMeant(arg)
             else:
                 done = True
+                self._install_upgraded_requires(txmbrs)
         if len(self.tsInfo) > oldcount:
             change = len(self.tsInfo) - oldcount
             return 2, [P_('%d package to install', '%d packages to install', change) % change]
@@ -732,9 +986,27 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return 0, [_('Nothing to do')]
         
     def updatePkgs(self, userlist, quiet=0, update_to=False):
-        """take user commands and populate transaction wrapper with 
-           packages to be updated"""
-        
+        """Take user commands and populate transaction wrapper with
+        packages to be updated.
+
+        :param userlist: a list of names or wildcards specifying
+           packages to update.  If *userlist* is an empty list, yum
+           will perform a global update
+        :param quiet: unused
+        :param update_to: if *update_to* is True, the update will only
+           be run if it will update the given package to the given
+           version.  For example, if the package foo-1-2 is installed,
+           updatePkgs(["foo-1-2], update_to=False) will work
+           identically to updatePkgs(["foo"]), but
+           updatePkgs(["foo-1-2"], update_to=True) will do nothing
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         # if there is no userlist, then do global update below
         # this is probably 90% of the calls
         # if there is a userlist then it's for updating pkgs, not obsoleting
